//CellNX̐錾
class Cell{

public:
	float latitude;				// ܓx [b] latitude [second]
	float longitude;				// ox [b] longitude [second]

	int down;					/* (NN1,NE2,EE3,SE4,SS5,SW6,WW7,NW8,͌0,En9,lȂ10,C-1) */
	int basin;					/* Wʐ */

	int numberOfUpStreamGrid;	/* 㗬Obh̐ */
	int riverNumber;			/* ͌ꂼԍŁÃObhǂ̉͌ɂȂĂ邩 */

	float longitudinalLength;	/* ox30b̒[m] */
	float med;					/* Ԓl[m] */

	class ROF* ROFCell;			/* ̃Obh܂܂~ʃZ */
	class Cell* downStreamGrid;	/* Obh */
	class Cell* upStreamGrid[7];/* 㗬Obh */

	int gridKind;	// kind of grid. 
					// -1: End of study region
					//  1: Inside of study region
					// 99: Dam

	float** mQn_1m;		/* array to store 1 month mQn */

//member and member function for kinematic wave method

	// p^
	double mMan_channel;	// Manning roughness coefficient for channel }jȎexW (m-s)
	double mMan_slope;	// Manning roughness coefficient for slope }jȎexW (m-s)
	double mKa;     // Hydraulic conductivity W (m-s)
	//double mD;      // Total Soil Layer yw (mn)
	double mDa;     // Aperturean Soil Layer 󌄕̓yw (mn)
	double mDm;     // Matrix Soil Layer }gNX̓yw (mn)
	double mBeta;   // Unsaturated Index sOaxw (-)
	double mVa;     // Velocity of Matrix Soil Layer 󌄕̓`dx (m-s)
	double mK;		// R = mK * pow(A, mZ) (mn)
	double mZ;		// R = mK * pow(A, mZ) (mn)
	double mL;		// length ͓ (m)
	double mB;      // width ͓ (m)
	double mG;		// gradient ͓z (tangent ̒l)
	int mDiv;		// number of space division ԕ (-)
	double mDx;		// space ԍԊu (m)
	int mDt;		// time  ԍԊu (sec)
	double mTheta;	// weight d݌W (-)

	int mThre_basin;// ΖʗƉ͓̋E㗬ʐ 

 	double mAlpha_slope;  // Ζʂkinematic 萔 
					 // mAlpha = 1 / mMan * pow(mK, 2/3) * sqrt(mG)
 	double mAlpha_channel;  // ͓kinematic 萔 
					 // mAlpha = 1 / mMan * pow(mK, 2/3) * sqrt(mG)

 	double mM;		// kinematic 萔
					// mM = 1 + 2/3*mZ

	// state variables ԗ
	double* mQc;	// current_time ł̗ (m3/s)
	double* mQn;	// current_time+time_step ł̗ (m3/s)
	double* mAc;	// current_time ł̒ʐfʐ (m2)
	double* mAn;	// current_time+time_step ł̒ʐfʐ (m2)
	double mQlc;	// current_time ł̑ (m2/s)
	double mQln;	// current_time+time_step ł̑ (m2/s)

	void setElevation(int rowStep, int colStep, int row, int col, float lat, float lon, int topoScale, float medElevation);
	void setNULL();
	void setDownStreamGrid(int row, int col, class Cell** cell2);	
	void setUpStreamGrid();
	void countNumberOfUpStreamGrid();
	void setROFCell(ROF** fROF, int row_ROF, int col_ROF);

	void initialize(double ini_lateral, int topoScale);
	void Set_parameter(double wMan_channel, double wMan_slope, double wKa, double wDa, double wDm, double wBeta, int thre_basin, int x_Div, int t_Div, double theta, int t_step_num, int topoScale);

	void getLateralRunoff(int n_day, int n_hour, int topoScale);
	void CalculateRiver(int day, int hour, int Ntime);
	void CalculateBasin(int day, int hour, int Ntime);

	float GetHourlyFlow(int day, int hour);
	float GetDailyFlow(int day);
	float GetHourlyFlowMax(int day);
	void deleteQandA();
};

